Attribute VB_Name = "modTGA"
'////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
'::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
'::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
'::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
'   Visual Basic:
' : Anakonda
' E-mail: anakonda@nm.ru
' : anakonda.nm.ru

'***  :
'      .
'    ,    RLE
'    (   QB     ).
'   32  .
'     ,      (   QB   ).
'   VB    Windows API  .
'::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
'::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
'::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

'   QBasic:
''''''''''''''''''''''''''''''''''''''''
'Version 0.1     '
' Programmer : Yousuf Philips          '
' Company    : Y P I                   '
' Updated On : 12th of June 1999       '
' Email - [philipz85@hotmail.com]      '
' [http://members.xoom.com/Philipz/]   '
''''''''''''''''''''''''''''''''''''''''

Option Explicit

Type RGBType
    R As Byte
    G As Byte
    B As Byte
End Type

Dim TGAHeader As TGAHeaderType

Dim pal(255) As RGBType
Dim n As Integer, n2 As Integer
Dim Bit16 As Long
Dim ImageIdentificationField$
Dim Palette$, Extract$, Byte1$, ExtractBytes$
Dim Movement As Long, BitsPerPixel As Integer, ImageType As Integer, Loops As Long, Blue As Byte, Green As Byte, Red As Byte
Dim YHeight As Long, XWidth As Long, BytesPerPixel As Integer, SM As Long
Dim pa As POINTAPI
Dim FileN As Integer

Public Enum ClrType
    Bit24
    Gray
    Bit8
End Enum

Type TGAHeaderType
   LengthOfField As String * 1    ' Length of the Image Identification Field
   ColorMap As String * 1         ' Color Map Type - 0 [No Map] 1 [256 Entry]
   ImageType As String * 1        ' Image Type
                                  ' [0] No Image Data Included
                                  ' [1] Uncompressed Color Map Image [4,8]
                                  ' [2] Uncompressed RGB Image [16,24]
                                  ' [3] Uncompressed Black & White
                                  ' [9] RLE Color Map Image
                                  ' [10] RLE RGB Image
                                  ' [11] RLE Black & White
                                  ' [32 | 33] Compressed Color Map using
                                  '           Huffman, Delta, RLE.
   OffsetOfColorMap As Integer    ' Offset of first color map entry (Not Imp)
   ColorsUsed As Integer          ' Number of color map entries (Not Imp)
   BitsPerColorMap As String * 1  ' Number of bits per color map entry(Not Imp)
   XCoordinate As Integer         ' Image X Co-ordinate of lower left corner(Not Imp)
   YCoordinate As Integer         ' Image Y Co-ordinate of lower left corner(Not Imp)
   ImageWidth As Integer          ' Width of image in pixels
   ImageHeight As Integer         ' Height of image in pixels
   BitsPerPixel As String * 1     ' Bits per pixel
   flags As String * 1            ' Flags (Not Imp)
   '/* Following the header is the Image Identification Field. Extract the
   '   number of bytes specified in LengthOfField
   '/* Following this is the Color Map Data
   '   If BitsPerColorMap = 32 then 1 byte for Red, Green, Blue & Attribute
   '   If BitsPerColorMap = 24 then 1 byte for Red, Green & Blue
   '   If BitsPerColorMap = 16 then 2 bytes [ARRRRRGG GGGBBBBB]
   '/* Following the color map is the image data
End Type

Public Declare Function GetPixel Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long) As Long
Private Declare Function SetPixel Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal crColor As Long) As Long

Private Type POINTAPI
        X As Long
        Y As Long
End Type

Private Declare Function LineTo Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long) As Long
Private Declare Function MoveToEx Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, lpPoint As POINTAPI) As Long


Function OpenTGA(FileName$, pic As PictureBox, Optional inPixels As Boolean) As Boolean
pic.Cls
OpenTGA = False

FileN = FreeFile
Palette$ = ""

Open FileName$ For Binary As FileN
If LOF(1) = 0 Then
   Debug.Print " File Is Empty"
   Close: Kill FileName$: GoTo EndOpen
End If

Get FileN, , TGAHeader

If Asc(TGAHeader.LengthOfField) <> 0 Then
   Debug.Print " Length of Image Identification Field "; Asc(TGAHeader.LengthOfField)
   ImageIdentificationField$ = Space$(Asc(TGAHeader.LengthOfField))
End If
If Asc(TGAHeader.ColorMap) = 0 Then
   Debug.Print " TGA Has No Color Map"
ElseIf Asc(TGAHeader.ColorMap) = 1 Then
   Debug.Print " TGA Has 256 Color Map"
Else
   Debug.Print " Not A Valid TGA File"
   GoTo EndOpen
End If
Movement = Asc(TGAHeader.BitsPerColorMap) \ 8
BitsPerPixel = Asc(TGAHeader.BitsPerPixel)
ImageType = Asc(TGAHeader.ImageType)

Select Case ImageType
   Case 0: Debug.Print " No Image Data Available"
   Case 1: Debug.Print " Uncompressed Color Image"
           Palette$ = Space$(Movement * TGAHeader.ColorsUsed)
   Case 2: Debug.Print " Uncompressed RGB Image"
   Case 3: Debug.Print " Uncompressed Black & White Image"
   Case 9: Debug.Print " Compressed Color Image"
           Palette$ = Space$(Movement * TGAHeader.ColorsUsed)
   Case 10: Debug.Print " Compressed RGB Image"
   Case 11: Debug.Print " Compressed Black & White Image"
End Select

Debug.Print " Width Of Image -"; TGAHeader.ImageWidth
Debug.Print " Height Of Image -"; TGAHeader.ImageHeight
Debug.Print " Bits Per Pixel -"; BitsPerPixel
Get FileN, , ImageIdentificationField$
Debug.Print ImageIdentificationField$

If Asc(TGAHeader.flags) = 32 Then SM = TGAHeader.ImageHeight Else SM = 0

If ImageType = 3 Or ImageType = 11 Then
   Debug.Print " Can't Display Image | Image Type Not Openable"
   GoTo EndOpen
ElseIf Asc(TGAHeader.BitsPerColorMap) = 16 Then
   Debug.Print " Can't Display Image | ColorMap - To Small"
   GoTo EndOpen
ElseIf Asc(TGAHeader.BitsPerPixel) <> 8 And Asc(TGAHeader.BitsPerPixel) <> 16 And Asc(TGAHeader.BitsPerPixel) <> 24 And Asc(TGAHeader.BitsPerPixel) <> 32 Then
   Debug.Print " Can't Display Image | BitsPerPixel -"; Asc(TGAHeader.BitsPerPixel)
   GoTo EndOpen
End If

If inPixels Then
    If pic.BorderStyle = 1 Then
        pic.Width = TGAHeader.ImageWidth + 4
        pic.Height = TGAHeader.ImageHeight + 4
    Else
        pic.Width = TGAHeader.ImageWidth
        pic.Height = TGAHeader.ImageHeight
    End If
Else
    If pic.BorderStyle = 1 Then
        pic.Width = (TGAHeader.ImageWidth + 4) '* Screen.TwipsPerPixelX
        pic.Height = (TGAHeader.ImageHeight + 4) ' * Screen.TwipsPerPixelY
    Else
        pic.Width = TGAHeader.ImageWidth '* Screen.TwipsPerPixelX
        pic.Height = TGAHeader.ImageHeight '* Screen.TwipsPerPixelY
    End If
End If


If Palette$ <> "" Then
   Get FileN, , Palette$
   For Loops = 0 To (2 ^ BitsPerPixel) - 1
      pal(Loops).B = Asc(Mid$(Palette$, Loops * Movement + 1, 1))
      pal(Loops).G = Asc(Mid$(Palette$, Loops * Movement + 2, 1))
      pal(Loops).R = Asc(Mid$(Palette$, Loops * Movement + 3, 1))
   Next Loops
Else
   For Loops = 0 To 255
      pal(Loops).R = Loops \ 4
      pal(Loops).G = Loops \ 4
      pal(Loops).B = Loops \ 4
   Next Loops
End If

If ImageType = 1 Or ImageType = 2 Then
      Extract$ = Space$(TGAHeader.ImageWidth * (BitsPerPixel \ 8))
      For YHeight = TGAHeader.ImageHeight - 1 To 0 Step -1
         Get FileN, , Extract$
         If BitsPerPixel = 8 Then
            For XWidth = 0 To TGAHeader.ImageWidth - 1
                n = Asc(Mid$(Extract$, XWidth + 1, 1))
                SetPixel pic.hdc, XWidth, Abs(SM - YHeight), RGB(pal(n).R, pal(n).G, pal(n).B)
            Next XWidth
         ElseIf BitsPerPixel = 16 Then
            For XWidth = 0 To TGAHeader.ImageWidth - 1
               Bit16 = Asc(Mid$(Extract$, (XWidth * 2) + 1, 1)) + Asc(Mid$(Extract$, (XWidth * 2) + 2, 1)) * 256
               Blue = Bit16 And 31: Bit16 = Bit16 \ 32
               Green = Bit16 And 31: Bit16 = Bit16 \ 32
               Red = Bit16 And 31
               
               Red = Red * 8
               Green = Green * 8
               Blue = Blue * 8
               SetPixel pic.hdc, XWidth, Abs(SM - YHeight), RGB(Red, Green, Blue)
            Next XWidth
         ElseIf BitsPerPixel = 24 Then
            For XWidth = 0 To TGAHeader.ImageWidth - 1
               Red = Asc(Mid$(Extract$, (XWidth * 3) + 3, 3))
               Green = Asc(Mid$(Extract$, (XWidth * 3) + 2, 3))
               Blue = Asc(Mid$(Extract$, (XWidth * 3) + 1, 3))
               SetPixel pic.hdc, XWidth, Abs(SM - YHeight), RGB(Red, Green, Blue)
            Next XWidth
         ElseIf BitsPerPixel = 32 Then
            For XWidth = 0 To TGAHeader.ImageWidth - 2
               Red = Asc(Mid$(Extract$, (XWidth * 4) + 3, 3))
               Green = Asc(Mid$(Extract$, (XWidth * 4) + 2, 3))
               Blue = Asc(Mid$(Extract$, (XWidth * 4) + 1, 3))
               SetPixel pic.hdc, XWidth, Abs(SM - YHeight), RGB(Red, Green, Blue)
            Next XWidth
         Else
            GoTo EndOpen
         End If
      Next YHeight
ElseIf ImageType = 9 Or ImageType = 10 Then
      MoveToEx pic.hdc, 0, 0, pa
      YHeight = TGAHeader.ImageHeight
      Byte1$ = Space$(1)
      BytesPerPixel = (BitsPerPixel \ 8)
      XWidth = 0
      Do
         Get FileN, , Byte1$
         Select Case Asc(Byte1$)
            Case 0 To 127:
               ExtractBytes$ = Space$((Asc(Byte1$) + 1) * BytesPerPixel)
               Get FileN, , ExtractBytes$
               If BitsPerPixel = 8 Then
                  For Movement = 0 To Asc(Byte1$)
                     n2 = Asc(Mid$(ExtractBytes$, Movement + 1, 1))
                     SetPixel pic.hdc, XWidth, Abs(SM - YHeight), RGB(pal(n2).R, pal(n2).G, pal(n2).B)
                     XWidth = XWidth + 1
                  Next Movement
               ElseIf BitsPerPixel = 16 Then
                  For Movement = 0 To Asc(Byte1$)
                     Bit16 = Asc(Mid$(ExtractBytes$, (Movement * 2) + 1, 1)) + Asc(Mid$(ExtractBytes$, (Movement * 2) + 2, 1)) * 256
                     Blue = Bit16 And 31: Bit16 = Bit16 \ 32
                     Green = Bit16 And 31: Bit16 = Bit16 \ 32
                     Red = Bit16 And 31
                     SetPixel pic.hdc, XWidth, Abs(SM - YHeight), RGB(Red, Green, Blue)
                     XWidth = XWidth + 1
                  Next Movement
               ElseIf BitsPerPixel = 24 Then
                  For Movement = 0 To Asc(Byte1$)
                     Red = Asc(Mid$(ExtractBytes$, (Movement * 3) + 3, 1))
                     Green = Asc(Mid$(ExtractBytes$, (Movement * 3) + 2, 1))
                     Blue = Asc(Mid$(ExtractBytes$, (Movement * 3) + 1, 1))
                     SetPixel pic.hdc, XWidth, Abs(SM - YHeight), RGB(Red, Green, Blue)
                     XWidth = XWidth + 1
                  Next Movement
               ElseIf BitsPerPixel = 32 Then
                  For Movement = 0 To Asc(Byte1$)
                     Red = Asc(Mid$(ExtractBytes$, (Movement * 4) + 3, 1))
                     Green = Asc(Mid$(ExtractBytes$, (Movement * 4) + 2, 1))
                     Blue = Asc(Mid$(ExtractBytes$, (Movement * 4) + 1, 1))
                     SetPixel pic.hdc, XWidth, Abs(SM - YHeight), RGB(Red, Green, Blue)
                     XWidth = XWidth + 1
                  Next Movement
               End If
            Case 128
            Case Else
               n = Asc(Byte1$) And 127
               ExtractBytes$ = Space$(BytesPerPixel)
               Get FileN, , ExtractBytes$
               If BitsPerPixel = 8 Then
                  n2 = Asc(ExtractBytes$)
                  MoveToEx pic.hdc, XWidth, Abs(SM - YHeight), pa
                  pic.ForeColor = RGB(pal(n2).R, pal(n2).G, pal(n2).B)
                  LineTo pic.hdc, XWidth + n + 1, Abs(SM - YHeight)
                  XWidth = XWidth + n + 1
               ElseIf BitsPerPixel = 16 Then
                  Bit16 = Asc(left$(ExtractBytes$, 1)) + Asc(right$(ExtractBytes$, 1)) * 256
                  Red = Bit16 And 31: Bit16 = Bit16 \ 32
                  Green = Bit16 And 31: Bit16 = Bit16 \ 32
                  Blue = Bit16 And 31
                  MoveToEx pic.hdc, XWidth, Abs(SM - YHeight), pa
                  pic.ForeColor = RGB(Red, Green, Blue)
                  LineTo pic.hdc, XWidth + n + 1, Abs(SM - YHeight)
                  XWidth = XWidth + n + 1
               ElseIf BitsPerPixel = 24 Then
                  Red = Asc(Mid$(ExtractBytes$, 3, 1))
                  Green = Asc(Mid$(ExtractBytes$, 2, 1))
                  Blue = Asc(Mid$(ExtractBytes$, 1, 1))
                  MoveToEx pic.hdc, XWidth, Abs(SM - YHeight), pa
                  pic.ForeColor = RGB(Red, Green, Blue)
                  LineTo pic.hdc, XWidth + n + 1, Abs(SM - YHeight)
                  XWidth = XWidth + n + 1
                ElseIf BitsPerPixel = 32 Then
                  Red = Asc(Mid$(ExtractBytes$, 3, 1))
                  Green = Asc(Mid$(ExtractBytes$, 2, 1))
                  Blue = Asc(Mid$(ExtractBytes$, 1, 1))
                  MoveToEx pic.hdc, XWidth, Abs(SM - YHeight), pa
                  pic.ForeColor = RGB(Red, Green, Blue)
                  LineTo pic.hdc, XWidth + n + 1, Abs(SM - YHeight)
                  XWidth = XWidth + n + 1
               End If
         End Select
         If XWidth >= TGAHeader.ImageWidth Then
            XWidth = 0: YHeight = YHeight - 1
         End If
         If YHeight = 0 Then
            Exit Do
         End If
      Loop
End If
OpenTGA = True

EndOpen:
Close
pic.Refresh
End Function

Public Function SaveTGA(sFileName As String, Pct As PictureBox, ByVal tp As ClrType) As Boolean
Dim x1 As Long, y1 As Long, nClr As Long, outputBits() As Byte, I As Integer
Dim R As Long, G As Long, B As Long
Dim DD3(767) As Byte
Dim W As Long, H As Long
Dim BitmapInformation As BITMAPINFO
Dim dib() As Byte
Dim WLen As Long
Dim X3 As Long
    
On Error Resume Next

With TGAHeader
    .LengthOfField = Chr(0)
    .ColorMap = Chr(0)
    .ImageType = Chr(2)
    ' ScaleMode     3 - Pixel
    .ImageHeight = Pct.ScaleHeight
    .ImageWidth = Pct.ScaleWidth
    .flags = Chr(0)
End With


    
If Dir(sFileName) <> "" Then Kill sFileName

FileN = FreeFile
Pct.AutoRedraw = True
ReDim outputBits(0)
I = 0
nClr = 0
R = 0
G = 0
B = 0

    W = Pct.Width
    H = Pct.Height
    With BitmapInformation.bmHeader
        .bmSize = Len(BitmapInformation.bmHeader)
        .bmBitCount = 24
        .bmClrImportant = 0
        .bmClrUsed = 0
        .bmCompression = 0&
        .bmHeight = H
        .bmWidth = W
        .bmPlanes = 1
        .bmSizeImage = 0
        .bmXPelsPerMeter = 0
        .bmYPelsPerMeter = 0
    End With
    WLen = ((W * 3 + 3) And &H7FFFFFFC) - 1
    ReDim dib(WLen, H - 1)
    GetDIBits Pct.hdc, Pct.Image, CLng(0), H, dib(0, 0), BitmapInformation, 0


Open sFileName For Binary As FileN
Select Case tp
Case Bit24
    ReDim outputBits((TGAHeader.ImageWidth - 1) * 3 + 2)
    TGAHeader.BitsPerPixel = Chr(24)
    TGAHeader.BitsPerColorMap = Chr(0)
    TGAHeader.ColorsUsed = 0
    Put FileN, , TGAHeader
    Put FileN, , dib
    Close FileN
Case Gray
    
    TGAHeader.BitsPerPixel = Chr(8)
    TGAHeader.BitsPerColorMap = Chr(24)
    TGAHeader.ImageType = Chr(1)
    TGAHeader.ColorMap = Chr(1)
    TGAHeader.ColorsUsed = 256
    
    Put FileN, , TGAHeader
    I = 0
    ReDim outputBits(767)
    
    '  
    For I = 0 To 767
        DD3(I) = CByte(I / 3)
    Next
    
    '  
    For I = 2 To 767
        outputBits(I - 2) = DD3(I)
        outputBits(I - 1) = DD3(I)
        outputBits(I) = DD3(I)
    Next I
    Put FileN, , outputBits
    
    ReDim outputBits(W - 1)
    '  
    For y1 = 0 To H - 1
        For x1 = 0 To W - 1
            X3 = x1 * 3
            Red = dib(X3, y1)
            Green = dib(X3 + 1, y1)
            Blue = dib(X3 + 2, y1)
            outputBits(x1) = DD3(Red) + DD3(Green) + DD3(Blue)
        Next
        Put FileN, , outputBits
    Next
    Close FileN
    
Case Bit8
    TGAHeader.BitsPerPixel = Chr(8)
    TGAHeader.BitsPerColorMap = Chr(24)
    TGAHeader.ImageType = Chr(1)
    TGAHeader.ColorMap = Chr(1)
    TGAHeader.ColorsUsed = 256
    
    Put FileN, , TGAHeader
    I = 0
    ReDim outputBits(767)
    
    For I = 0 To 255
        DD3(I) = CInt(I / 50)
    Next
    
    '  
    I = 0
    For B = 0 To 256 Step 50
        For G = 0 To 256 Step 50
            For R = 0 To 256 Step 50
                If B = 256 Then B = 255
                If R = 256 Then R = 255
                If G = 256 Then G = 255
                outputBits(I) = B
                outputBits(I + 1) = G
                outputBits(I + 2) = R
                I = I + 3
            Next R
        Next G
    Next B
    Put FileN, , outputBits
    
    ReDim outputBits(TGAHeader.ImageWidth - 1)
    '  
    For y1 = 0 To H - 1
        For x1 = 0 To W - 1
            X3 = x1 * 3
            Blue = dib(X3, y1)
            Green = dib(X3 + 1, y1)
            Red = dib(X3 + 2, y1)
            outputBits(x1) = DD3(Green) * 6 + DD3(Red) + DD3(Blue) * 36
        Next
        Put FileN, , outputBits
    Next
    Close FileN
End Select
SaveTGA = err.Number = 0
End Function
