Attribute VB_Name = "modPSD"
Option Explicit

Public Const SRCCOPY = &HCC0020 ' (DWORD) dest = source
Public Const DIB_RGB_COLORS = 0 '  color table in RGBs

Type RGBQUAD
        rgbBlue As Byte
        rgbGreen As Byte
        rgbRed As Byte
        rgbReserved As Byte
End Type

Type BITMAPFILEHEADER
        bfType As Integer
        bfSize As Long
        bfReserved1 As Integer
        bfReserved2 As Integer
        bfOffBits As Long
End Type

Private Type BITMAPINFOHEADER '40 bytes
        biSize As Long
        biWidth As Long
        biHeight As Long
        biPlanes As Integer
        biBitCount As Integer
        biCompression As Long
        biSizeImage As Long
        biXPelsPerMeter As Long
        biYPelsPerMeter As Long
        biClrUsed As Long
        biClrImportant As Long
End Type

Private Type BITMAPINFO
        bmiHeader As BITMAPINFOHEADER
        bmiColors As RGBQUAD
End Type

Public Type API_RECT
    left As Long
    top As Long
    right As Long
    bottom As Long
End Type

Declare Function StretchDIBits Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal dx As Long, ByVal dY As Long, _
        ByVal SrcX As Long, ByVal SrcY As Long, ByVal wSrcWidth As Long, ByVal wSrcHeight As Long, lpBits As Any, lpBitsInfo As BITMAPINFO, _
        ByVal wUsage As Long, ByVal dwRop As Long) As Long
'Declare Function SetRect Lib "user32" (lpRect As Rect, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long

'============================================================================================================
Public Const TLPSD_MAXSTR = 68

'Public Type TLKISS_CELHEADER
'    ID As Long
'    Marker As Byte
'    Depth As Byte
'    Pad As Integer
'    Width As Integer
'    Height  As Integer
'    OffsetX  As Integer
'    OffsetY  As Integer
'    Reserved(3) As Long
'End Type

Public Type TLPSD_IMAGEINFO
    nIndex As Long         '// Zero-oder layer index.
    nGroup As Long        ' // Linkage between layers. If a layer has negative value, the layer has not any linkage.
    rcImage As API_RECT
    szName As String * TLPSD_MAXSTR
    bfVisible As Long      '// TRUE=visible, FLASE=unvisible layer
    szBlendMode As String * 8  '// Blend mode key
    nOpacity As Long       '// 0=transparent, 0XFF=opaque
    bfMaskVisible As Long  '// TRUE=visible, FLASE=unvisible layer
End Type

'Declare Function TlPsdLoad_GetVersion Lib "psd.dll" () As Long
Declare Function TlPsdLoad_Open Lib "psd.dll" (ByVal sFileName As String, ByVal MaxSize As Long, ByVal Mode As Long) As Long
Declare Sub TlPsdLoad_Close Lib "psd.dll" ()
'Declare Function TlPsdLoad_GetLayerCount Lib "psd.dll" () As Long
Declare Function TlPsdLoad_GetImageInfo Lib "psd.dll" (ByRef info As TLPSD_IMAGEINFO) As Long
Declare Function TlPsdLoad_GetImage Lib "psd.dll" (ByVal Index As Long, ByRef Image As Any, ByVal Size As Long, ByRef rc As API_RECT) As Long

Declare Sub TlPsdLoad_UnderScan Lib "psd.dll" (ByRef pImage As Any, ByRef rcImage As API_RECT, ByRef rcFrame As API_RECT)
Declare Sub TlPsdLoad_Minimize Lib "psd.dll" (ByRef pImage As Any, ByRef rcImage As API_RECT)

Public Function RectHeight(rc As API_RECT) As Long

    With rc
        RectHeight = .bottom - .top
    End With

End Function

Public Function RectWidth(rc As API_RECT) As Long

    With rc
        RectWidth = .right - .left
    End With

End Function

Public Function LoadPsd(sOpenFile As String, pic As PictureBox, Optional ByRef RezStr As String, Optional inPixels As Boolean) As Boolean

    Dim image_info As TLPSD_IMAGEINFO
    Dim Image() As RGBQUAD
    Dim PixCount As Long, PixelBuffSize As Long, Err As Long
    Dim rcFrame As API_RECT
    Dim sMsg As String
    
    RezStr = ""
    LoadPsd = False
    pic.Cls
    pic.Picture = Nothing
    pic.Height = 1
    pic.Width = 1
    pic.ScaleMode = vbPixels
    PixelBuffSize = 0
    

    ' ======= Open PSD file =======
    ' Open a psd file by read-only and sharing mode.
    If TlPsdLoad_Open(sOpenFile, 2048&, 0&) <> 0 Then
        RezStr = " : " + Str(Err)
        Exit Function
    End If
   
    ' Retreve an image information form a psd file for getting rectangular parameter.
    ' The rectangle is used for triming image.
    image_info.nIndex = -1
    Call TlPsdLoad_GetImageInfo(image_info)
    rcFrame = image_info.rcImage
   
    ' ======= Get Image=======
    With image_info
        .nIndex = -1
        ' Retrieve image and layer informations from a psd file.
        While TlPsdLoad_GetImageInfo(image_info) = 0
            PixCount = RectWidth(.rcImage) * RectHeight(.rcImage)
            If PixCount > 0 Then ' If PixCount = 0,  there is not any layer's pixel data.
                If PixelBuffSize < PixCount - 1 Then
                    PixelBuffSize = PixCount - 1
                    ReDim Image(PixCount - 1) As RGBQUAD
                End If
                ' Retrieve image and layer data from a psd file.
                If TlPsdLoad_GetImage(.nIndex, Image(0), PixCount * 4, .rcImage) = 0 Then
               
                    Select Case .nIndex
                    Case -1 ' merged image
                        ' Show the merged image to the Form1 window.
                        Call ShowBitmap(Image, .rcImage, PixCount, pic, inPixels)
                    Case Else ' layer image
                        ' Trim the image
                        Call TlPsdLoad_UnderScan(Image(0), .rcImage, rcFrame)
                        Call TlPsdLoad_Minimize(Image(0), .rcImage)
                        If RectWidth(.rcImage) > 0 And RectHeight(.rcImage) > 0 Then
                            sMsg = Replace(left(.szBlendMode, InStr(.szBlendMode, vbNullChar)) + vbTab + left(.szName, InStr(.szName, vbNullChar)), Chr(0), "")
                            RezStr = RezStr + " " + Str(.nIndex) + vbTab + "  (" + Str(RectWidth(.rcImage)) + ", " + Str(RectHeight(.rcImage)) + ") " + vbTab + Str(.nOpacity) + vbTab + sMsg + vbNewLine
                        End If
                    End Select
                End If
            End If
            .nIndex = .nIndex + 1
        Wend
    End With
       
    ' ======= Close the opend PSD file =======
    Call TlPsdLoad_Close
    pic.Refresh
    LoadPsd = True
End Function

Private Sub GetBitmapHeader(bmfh As BITMAPFILEHEADER, bmih As BITMAPINFOHEADER, ByRef Rect As API_RECT)

    Dim n As Long
   
    n = 256
   
    With bmih
        .biSize = Len(bmih)
        .biBitCount = 32
        .biHeight = RectHeight(Rect)
        .biWidth = RectWidth(Rect)
        .biSizeImage = .biWidth * .biHeight * 4
        .biPlanes = 1
    End With
   
    With bmfh
        .bfType = Asc("B") + Asc("M") * n
        .bfOffBits = bmih.biSize + Len(bmfh)
        .bfSize = .bfOffBits + bmih.biSizeImage
    End With

End Sub

Private Sub ShowBitmap(ByRef Image() As RGBQUAD, ByRef Rect As API_RECT, PixCount As Long, pic As PictureBox, inPixels As Boolean)

    Dim bmfh As BITMAPFILEHEADER
    Dim bmi As BITMAPINFO
   
    If inPixels Then
        If Rect.bottom > pic.ScaleHeight Then pic.Height = Rect.bottom
        If Rect.right > pic.ScaleWidth Then pic.Width = Rect.right
    Else
        If Rect.bottom > pic.ScaleHeight Then pic.Height = Rect.bottom '* Screen.TwipsPerPixelY
        If Rect.right > pic.ScaleWidth Then pic.Width = Rect.right '* Screen.TwipsPerPixelX
    End If
    
    With bmi.bmiHeader
        Call GetBitmapHeader(bmfh, bmi.bmiHeader, Rect)
        Call StretchDIBits(pic.hdc, 0, .biHeight - 1, .biWidth, -.biHeight, 0, 0, .biWidth, .biHeight, Image(0), bmi, DIB_RGB_COLORS, SRCCOPY)
    End With

End Sub

