Attribute VB_Name = "ComDlg"

Private Declare Function GetOpenFileName Lib "comdlg32.dll" Alias "GetOpenFileNameA" (pOpenfilename As OPENFILENAME) As Long
Private Declare Function GetSaveFileName Lib "comdlg32.dll" Alias "GetSaveFileNameA" (pOpenfilename As OPENFILENAME) As Long

'  Common Dialog
Public Enum CommonDialogOFN_Flags
    cdlOFNAllowMultiselect = &H200
    cdlOFNCreatePrompt = &H2000
    cdlOFNExplorer = &H80000
    cdlOFNExtensionDifferent = &H400
    cdlOFNFileMustExist = &H1000
    cdlOFNHelpButton = &H10
    cdlOFNHideReadOnly = &H4
    cdlOFNLongNames = &H200000
    cdlOFNNoChangeDir = &H8
    cdlOFNNoDereferenceLinks = &H100000
    cdlOFNNoLongNames = &H40000
    cdlOFNNoReadOnlyReturn = &H8000
    cdlOFNNoValidate = &H100
    cdlOFNOverwritePrompt = &H2
    cdlOFNPathMustExist = &H800
    cdlOFNReadOnly = &H1
    cdlOFNShareAware = &H4000
End Enum

Private Type rezDlgFont
    FontItalic As Boolean
    FontUnderline As Boolean
    FontStrikethru As Boolean
    FontName As String
    FontSize As Long
    FontBold As Boolean
    FontColor As Long
    FontCharSet As Long
End Type

'      .
Public ChosenFont As rezDlgFont

'    ,   -  ,   ,    ...
Private mRGBResult     As Long
Private iAction        As Integer
Private bCancelError   As Boolean
Private lColor         As Long
Private lHDC           As Long
Private lHelpCommand   As Long
Private lApiReturn     As Long
Private lExtendedError As Long
Dim fn                 As String
Dim A1                 As Boolean
'   \ .
Private OFN            As OPENFILENAME
Private Type OPENFILENAME
    lStructSize As Long
    hwndOwner As Long
    hInstance As Long
    lpstrFilter As String
    lpstrCustomFilter As String
    nMaxCustFilter As Long
    nFilterIndex As Long
    lpstrFile As String
    nMaxFile As Long
    lpstrFileTitle As String
    nMaxFileTitle As Long
    lpstrInitialDir As String
    lpstrTitle As String
    flags As Long
    nFileOffset As Integer
    nFileExtension As Integer
    lpstrDefExt As String
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As String
End Type

'   :)
Private mCancelError As Boolean

Public Function dlgOpenFile(defVal As String, Optional filter As String, Optional startFolder As String, Optional DialogTitle As String, Optional opcFlags As CommonDialogOFN_Flags, Optional FormHwnd As Long) As String
    On Error Resume Next

    '    -  
    If filter = "" Then filter = " |*.*|"
    If DialogTitle = "" Then DialogTitle = " "
    If startFolder = "" Then startFolder = CurDir$
    ''SendData "dlgOpenFile 2"
    '      ,     
    OFN.lStructSize = Len(OFN)
    OFN.hwndOwner = FormHwnd
    OFN.hInstance = App.hInstance
    OFN.lpstrFilter = Replace(filter, "|", Chr(0))
    OFN.lpstrFile = Space$(254)
    OFN.nMaxFile = 255
    OFN.nFilterIndex = FilterIndex
    OFN.lpstrFileTitle = Space$(254)
    OFN.nMaxFileTitle = 255
    OFN.lpstrInitialDir = startFolder
    OFN.lpstrTitle = DialogTitle
    OFN.flags = opcFlags
    ''SendData "dlgOpenFile 3"
    'SendData defVal
    'SendData filter
    'SendData startFolder
    'SendData DialogTitle
    'SendData Str(Val(opcFlags))
    'SendData Str(Val(FormHwnd))

    Dim op As Long

    op = GetOpenFileName(OFN)     '  
    ''SendData "dlgOpenFile 4"

    '  
    If (op) Then
        dlgOpenFile = Replace(Trim$(OFN.lpstrFile), Chr$(0), "")
        FilterIndex = OFN.nFilterIndex
    Else
        dlgOpenFile = defVal
    End If

    ''SendData "dlgOpenFile 5"
End Function

Public Function dlgSaveFile(defVal As String, Optional filter As String, Optional startFolder As String, Optional DialogTitle As String, Optional opcFlags As CommonDialogOFN_Flags, Optional FormHwnd As Long, Optional dName As String = "", Optional FilterIndex) As String

    On Error Resume Next

    '          ,    ...
    If filter = "" Then filter = " |*.*|"
    If DialogTitle = "" Then DialogTitle = " "
    If startFolder = "" Then startFolder = CurDir$
  
    OFN.lStructSize = Len(OFN)
    OFN.hwndOwner = FormHwnd
    OFN.hInstance = App.hInstance
    OFN.lpstrFilter = Replace(filter, "|", Chr(0))
    OFN.lpstrFile = dName & Space$(254 - Len(dName))
    OFN.nMaxFile = 255
    OFN.nFilterIndex = FilterIndex
    OFN.lpstrFileTitle = Space$(254)
    OFN.nMaxFileTitle = 255
    OFN.lpstrInitialDir = startFolder
    OFN.lpstrTitle = DialogTitle
    OFN.flags = opcFlags
  
    Dim op As Long

    op = GetSaveFileName(OFN) '       
  
    If op Then
        dlgSaveFile = Replace(Trim$(OFN.lpstrFile), Chr(0), "")
        FilterIndex = OFN.nFilterIndex
    Else
        dlgSaveFile = defVal
    End If

End Function

Public Function dlgExtension(fName As String) As String
Dim I As Long, I1 As Long
On Error GoTo Err:
    I = InStrRev(fName, ".")
    If I <> 0 Then
        I1 = InStrRev(fName, "\")
        If I > I1 Then
            dlgExtension = LCase$(right$(fName, Len(fName) - InStrRev(fName, ".")))
        Else
            dlgExtension = ""
        End If
    Else
        dlgExtension = ""
    End If
Err:
End Function

Public Function dlgPathFolder(fName As String) As String
On Error GoTo Err:
    If InStrRev(fName, "\") <> 0 Then
        dlgPathFolder = LCase(left$(fName, InStrRev(fName, "\")))
    Else
        dlgPathFolder = App.Path
    End If
Err:
End Function

Public Function dlgFileName(fName As String) As String
On Error GoTo Err:
    fn = right$(fName, Len(fName) - InStrRev(fName, "\"))
    dlgFileName = left$(fn, InStrRev(fn, ".") - 1)
Err:
End Function

