Attribute VB_Name = "GDI"
Public Type BITMAPINFOHEADER
  bmSize As Long
  bmWidth As Long
  bmHeight As Long
  bmPlanes As Integer
  bmBitCount As Integer
  bmCompression As Long
  bmSizeImage As Long
  bmXPelsPerMeter As Long
  bmYPelsPerMeter As Long
  bmClrUsed As Long
  bmClrImportant As Long
End Type
Public Type RGBTriple
  Blue As Byte
  Green As Byte
  Red As Byte
End Type
Public Type BITMAPINFO
  bmHeader As BITMAPINFOHEADER
  bmColors(0 To 255) As RGBTriple
End Type

Private Type cPoint
  X As Integer
  Y As Integer
End Type

Public Declare Function GetPixel Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long) As Long
Public Declare Function SetPixel Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal crColor As Long) As Long
Public Declare Function SetCapture Lib "user32" (ByVal hwnd As Long) As Long
Public Declare Function GetCapture Lib "user32" () As Long
Public Declare Function ReleaseCapture Lib "user32" () As Long
Public Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Public Declare Function TransparentBlt Lib "msimg32.dll" (ByVal hdcDest As Long, ByVal nXOriginDest As Long, ByVal nYOriginDest As Long, ByVal nWidthDest As Long, ByVal nHeightDest As Long, ByVal hdcSrc As Long, ByVal nXOriginSrc As Long, ByVal nYOriginSrc As Long, ByVal nWidthSrc As Long, ByVal nHeightSrc As Long, ByVal crTransparent As Long) As Long
Public Declare Function TextOut& Lib "gdi32" Alias "TextOutA" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal lpString As String, ByVal nCount As Long)
Public Declare Function GetDC Lib "user32" (ByVal hwnd As Long) As Long

Public Declare Function SetGraphicsMode Lib "gdi32" (ByVal hdc As Long, ByVal iMode As Long) As Long
Public Declare Function Ellipse Lib "gdi32" (ByVal hdc As Long, ByVal x1 As Long, ByVal y1 As Long, ByVal x2 As Long, ByVal y2 As Long) As Long
'Public Declare Function SetBkColor Lib "gdi32" (ByVal HDC As Long, ByVal crColor As Long) As Long
'Public Declare Function SetBkMode Lib "gdi32" (ByVal HDC As Long, ByVal nBkMode As Long) As Long
'Public Declare Function Arc Lib "gdi32" (ByVal HDC As Long, ByVal x1 As Long, ByVal y1 As Long, ByVal x2 As Long, ByVal y2 As Long, ByVal X3 As Long, ByVal Y3 As Long, ByVal X4 As Long, ByVal Y4 As Long) As Long
'Public Declare Function Polygon Lib "gdi32" (ByVal hdc As Long, ByRef lpPoint As POINTAPI, ByVal nCount As Long) As Long

Public Declare Function PlgBlt Lib "gdi32" (ByVal hdcDest As Long, lpPoint As POINTAPI, ByVal hdcSrc As Long, ByVal nXSrc As Long, ByVal nYSrc As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hbmMask As Long, ByVal xMask As Long, ByVal yMask As Long) As Long

Public Declare Function ExtFloodFill Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal crColor As Long, ByVal wFillType As Long) As Long

Public Declare Function DeleteFile Lib "kernel32" Alias "DeleteFileA" (ByVal lpFileName As String) As Long

Public Declare Function StretchBlt Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, ByVal dwRop As Long) As Long
Public Declare Function SetStretchBltMode Lib "gdi32" (ByVal hdc As Long, ByVal nStretchMode As Long) As Long

Public Declare Function SetDIBits Lib "Gdi32.dll" (ByVal hdc As Long, ByVal hBitmap As Long, ByVal nStartScan As Long, ByVal nNumScans As Long, ByRef lpBits As Any, ByRef lpBI As BITMAPINFO, ByVal wUsage As Long) As Long
Public Declare Function GetDIBits Lib "Gdi32.dll" (ByVal hdc As Long, ByVal hBitmap As Long, ByVal nStartScan As Long, ByVal nNumScans As Long, lpBits As Any, lpBI As BITMAPINFO, ByVal wUsage As Long) As Long
Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (pDest As Any, pSrc As Any, ByVal cbSize As Long)
'Public Declare Sub FillMemory Lib "kernel32.dll" Alias "RtlFillMemory" (Destination As Any, ByVal Length As Long, ByVal Fill As Byte)
'Public Declare Sub ZeroMemory Lib "kernel32.dll" Alias "RtlZeroMemory" (Destination As Any, ByVal Length As Long)

Dim tmpData() As Long
Dim tmpData1() As Long
'Dim tmpLength As Long
Dim BIF As BITMAPINFO
'Dim BIF1 As BITMAPINFO

Sub DrwEllipse(dHDC As Long, x1, y1, x2, y2)
  Xp = IIf(x1 < x2, x1, x2)
  Yp = IIf(y1 < y2, y1, y2)
  W = Abs(x2 - x1)
  H = Abs(y2 - y1)
  Ellipse dHDC, Xp, Yp, CInt(Xp + W + 0.9), CInt(Yp + H + 0.9)
End Sub

Sub DrawPlg(DestDC, x1, y1, x2, y2, X3, Y3, SrcDC, sX, sY, sWidth, sHeight)
  Dim pts(2) As POINTAPI
  Dim di As Long
  pts(0).X = x1
  pts(0).Y = y1
  pts(1).X = x2
  pts(1).Y = y2
  pts(2).X = X3
  pts(2).Y = Y3
  di = PlgBlt(DestDC, pts(0), SrcDC, sX, sY, sWidth, sHeight, 0, 0, 0)
End Sub
Sub RotPic(DestDC, dx, dY, dWidth, dHeight, SrcDC, sX, sY, sWidth, sHeight, Angel, Optional scX As Single = 1, Optional scY As Single = 1)
  H = Sqr(dWidth ^ 2 + dHeight ^ 2) / 2
  Agl1 = UgN(0, 0, -dWidth / 2, -dHeight / 2)
  Agl2 = UgN(0, 0, dWidth / 2, -dHeight / 2)
  Agl3 = UgN(0, 0, -dWidth / 2, dHeight / 2)
  A1 = dx + Sin(-Angel + Agl1) * H * scX
  b1 = dY + Cos(-Angel + Agl1) * H * scY
  A2 = dx + Sin(-Angel + Agl2) * H * scX
  b2 = dY + Cos(-Angel + Agl2) * H * scY
  A3 = dx + Sin(-Angel + Agl3) * H * scX
  B3 = dY + Cos(-Angel + Agl3) * H * scY
  DrawPlg DestDC, A1, b1, A2, b2, A3, B3, SrcDC, sX, sY, sWidth, sHeight
End Sub
Function GetRotPar(dstW, dstH, sWidth, sHeight, Angel, Optional scX As Single = 1, Optional scY As Single = 1)
  Dim ax(3) As Long
  Dim ay(3) As Long
  H = Sqr(sWidth ^ 2 + sHeight ^ 2) / 2
  Agl1 = UgN(0, 0, -sWidth / 2, -sHeight / 2)
  Agl2 = UgN(0, 0, sWidth / 2, -sHeight / 2)
  Agl3 = UgN(0, 0, -sWidth / 2, sHeight / 2)
  Agl4 = UgN(0, 0, sWidth / 2, sHeight / 2)
  ax(0) = Sin(-Angel + Agl1) * H * scX
  ay(0) = Cos(-Angel + Agl1) * H * scY
  ax(1) = Sin(-Angel + Agl2) * H * scX
  ay(1) = Cos(-Angel + Agl2) * H * scY
  ax(2) = Sin(-Angel + Agl3) * H * scX
  ay(2) = Cos(-Angel + Agl3) * H * scY
  ax(3) = Sin(-Angel + Agl4) * H * scX
  ay(3) = Cos(-Angel + Agl4) * H * scY
  
  minX = 9999
  minY = 9999
  maxX = -9999
  maxY = -9999
  For n = 0 To 3
    If ax(n) < minX Then minX = ax(n)
    If ay(n) < minY Then minY = ay(n)
    If ax(n) > maxX Then maxX = ax(n)
    If ay(n) > maxY Then maxY = ay(n)
  Next
  dstW = maxX - minX
  dstH = maxY - minY
End Function

Function ReverseColor(C As Long) As Long
  Dim D As RGBTriple
  CopyMemory D, C, 3
  ReverseColor = RGB(D.Red, D.Green, D.Blue)
End Function
      
Sub MagicSelect(im As PictureBox, Xp, Yp)
  Dim BitmapInformation As BITMAPINFO
  'Dim BitmapInformation2 As BITMAPINFO
  
  Dim temp() As Long
  Dim temp2() As Long
  
  Dim pnt() As cPoint
  Dim mss() As Byte
  Dim CurPoint As Long
  Dim OldPoint As Long

  Dim DN As Long
  Dim TC As Long
  Dim BC As Long
  Dim W As Long
  Dim H As Long
  'W-1, H-1
  Dim W1 As Long
  Dim H1 As Long
  
  Dim Xp1 As Integer
  Dim Yp1 As Integer
  Dim Xm1 As Integer
  Dim Ym1 As Integer
  Dim bk As Integer
  
  '  
  Dim n As Long
  Dim MunisXp() As Integer
  Dim MunisYp() As Integer
  
  '    N - Xp  N - Yp
  ReDim MunisXp(Xp - Size - 1 To Xp + Size + 1)
  ReDim MunisYp(Yp - Size - 1 To Yp + Size + 1)
  For n = Xp - Size - 1 To Xp + Size + 1
    MunisXp(n) = n - Xp
  Next
  For n = Yp - Size - 1 To Yp + Size + 1
    MunisYp(n) = n - Yp
  Next
  
        
  Set frmMain.tmpEdit.Picture = frmMain.im.Picture
  frmMain.tmpEdit.Picture = LoadPicture
  frmMain.tmpEdit.Line (0, 0)-(im.Width - 1, im.Height - 1), BotColor, BF
  frmMain.tmpEdit.Width = im.Width
  frmMain.tmpEdit.Height = im.Height
  
  
  W = im.Width: H = im.Height
  ReDim pnt(W * H - 1)
  ReDim temp(W - 1, H - 1)
  ReDim temp2(W - 1, H - 1)
  ReDim mss(W - 1, H - 1)
  
  With BitmapInformation.bmHeader
    .bmSize = Len(BitmapInformation.bmHeader)
    .bmBitCount = 32
    .bmClrImportant = 0
    .bmClrUsed = 0
    .bmCompression = BI_RGB
    .bmHeight = H
    .bmWidth = W
    .bmPlanes = 1
    .bmSizeImage = 0
    .bmXPelsPerMeter = 0
    .bmYPelsPerMeter = 0
  End With

  GetDIBits frmMain.im.hdc, frmMain.im.Image, CLng(0), H, temp(0, 0), BitmapInformation, DIB_RGB_COLORS
  GetDIBits frmMain.tmpEdit.hdc, frmMain.tmpEdit.Image, CLng(0), H, temp2(0, 0), BitmapInformation, DIB_RGB_COLORS
  
  W1 = W - 1
  H1 = H - 1
  
  pnt(0).X = Xp
  pnt(0).Y = Yp
  mss(Xp, Yp) = 1
  TC = temp2(Xp, Yp)
  DN = temp(Xp, Yp)
  If DN = TC Then MsgBox "    ", vbInformation, "": Exit Sub
  
  minX = W
  minY = H
  maxX = 0
  maxY = 0
  
  CurPoint = 0
  OldPoint = 0
  k = 1
  Do While k = 1
  k = 0
  bk = 0

  For n = OldPoint To CurPoint
    X = pnt(n).X
    Y = pnt(n).Y
    If X < minX Then minX = X
    If Y < minY Then minY = Y
    If X > maxX Then maxX = X
    If Y > maxY Then maxY = Y
    temp(X, Y) = TC
    temp2(X, Y) = DN
    Xp1 = Plus1(X) ' + 1
    Yp1 = Plus1(Y) ' + 1
    Xm1 = Minus1(X) ' - 1
    Ym1 = Minus1(Y) ' - 1
    bk = Plus1(bk) ' + 1
    
    If X > 0 Then
      If mss(Xm1, Y) = 0 Then
        If temp(Xm1, Y) = DN And temp2(Xm1, Y) = TC Then
          CurPoint = CurPoint + 1
          pnt(CurPoint).X = Xm1
          pnt(CurPoint).Y = Y
          k = 1
          mss(Xm1, Y) = 1
        End If
      End If
    End If
    
    If X < W1 Then
      If mss(Xp1, Y) = 0 Then
        If temp(Xp1, Y) = DN And temp2(Xp1, Y) = TC Then
          CurPoint = CurPoint + 1
          pnt(CurPoint).X = Xp1
          pnt(CurPoint).Y = Y
          k = 1
          mss(Xp1, Y) = 1
        End If
      End If
    End If
    
    If Y > 0 Then
      If mss(X, Ym1) = 0 Then
        If temp(X, Ym1) = DN And temp2(X, Ym1) = TC Then
          CurPoint = CurPoint + 1
          pnt(CurPoint).X = X
          pnt(CurPoint).Y = Ym1
          k = 1
          mss(X, Ym1) = 1
        End If
      End If
    End If
    
    If Y < H1 Then
      If mss(X, Yp1) = 0 Then
        If temp(X, Yp1) = DN And temp2(X, Yp1) = TC Then
          CurPoint = CurPoint + 1
          pnt(CurPoint).X = X
          pnt(CurPoint).Y = Yp1
          k = 1
          mss(X, Yp1) = 1
        End If
      End If
    End If
    
  Next
  OldPoint = OldPoint + bk
  Loop
  
  frmMain.tmpBuffer.Picture = LoadPicture
  frmMain.tmpBuffer.Width = W
  frmMain.tmpBuffer.Height = H
  SetDIBits frmMain.tmpEdit.hdc, frmMain.tmpEdit.Image, CLng(0), H, temp2(0, 0), BitmapInformation, DIB_RGB_COLORS
  SetDIBits im.hdc, im.Image, CLng(0), H, temp(0, 0), BitmapInformation, DIB_RGB_COLORS
  
  W = maxX - minX + 1
  H = maxY - minY + 1
  selY = im.Height - (minY + H)
  frmMain.tmpBuffer.Width = W
  frmMain.tmpBuffer.Height = H
  BitBlt frmMain.tmpBuffer.hdc, 0, 0, W, H, frmMain.tmpEdit.hdc, minX, selY, vbSrcCopy
  
  selX = minX
  selW = W: selH = H
  selIs = 1
End Sub

Sub IntiBrushImage(im As PictureBox)
  Dim W As Long
  Dim H As Long
  W = im.Width: H = im.Height
  ReDim tmpData(W - 1, H - 1)
  ReDim tmpData1(W - 1, H - 1)
  With BIF.bmHeader
    .bmSize = Len(BIF.bmHeader)
    .bmBitCount = 32
    .bmClrImportant = 0
    .bmClrUsed = 0
    .bmCompression = BI_RGB
    .bmHeight = H
    .bmWidth = W
    .bmPlanes = 1
    .bmSizeImage = 0
    .bmXPelsPerMeter = 0
    .bmYPelsPerMeter = 0
  End With
  GetDIBits im.hdc, im.Image, CLng(0), H, tmpData(0, 0), BIF, DIB_RGB_COLORS
  GetDIBits im.hdc, im.Image, CLng(0), H, tmpData1(0, 0), BIF, DIB_RGB_COLORS
End Sub
Sub DrawBrushImage(im As PictureBox)
  Dim H As Long
  W = im.Width: H = im.Height
  SetDIBits im.hdc, im.Image, CLng(0), H, tmpData(0, 0), BIF, DIB_RGB_COLORS
End Sub
Sub MagicBrush(im As PictureBox, Xp, Yp, Color As Long, Size As Long)
  Dim pnt() As cPoint
  Dim mss() As Byte
  Dim CurPoint As Long
  Dim OldPoint As Long
  Dim DN As Long
  Dim TC As Long
  Dim BC As Long
  Dim W As Long
  Dim H As Long
  Dim W1 As Long
  Dim H1 As Long
  Dim Xp1 As Integer
  Dim Yp1 As Integer
  Dim Xm1 As Integer
  Dim Ym1 As Integer
  Dim bk As Integer
  Dim mX As Long
  Dim mY As Long
  Dim SZ2 As Long
  Dim MunisXp() As Integer
  Dim MunisYp() As Integer
  '  
  Dim n As Long
  
  SZ2 = Size + 1
  W = im.Width: H = im.Height
  ReDim pnt((Size * 2) ^ 2)
  'ReDim mss(W - 1, H - 1)
  ReDim mss(Xp - Size - 2 To Xp + Size + 2, Yp - Size - 2 To Yp + Size + 2)
  '    N - Xp  N - Yp
  ReDim MunisXp(Xp - Size - 2 To Xp + Size + 2)
  ReDim MunisYp(Yp - Size - 2 To Yp + Size + 2)
  For n = Xp - Size - 2 To Xp + Size + 2
    MunisXp(n) = n - Xp
  Next
  For n = Yp - Size - 2 To Yp + Size + 2
    MunisYp(n) = n - Yp
  Next
  W1 = W - 1
  H1 = H - 1
  pnt(0).X = Xp
  pnt(0).Y = Yp
  mss(Xp, Yp) = 1
  TC = ReverseColor(Color)
  DN = tmpData1(Xp, Yp)
  CurPoint = 0
  OldPoint = 0
  k = 1
  Do While k = 1
  k = 0
  bk = 0
  For n = OldPoint To CurPoint
    X = pnt(n).X
    Y = pnt(n).Y
    tmpData(X, Y) = TC
    Xp1 = Plus1(X) ' X + 1
    Yp1 = Plus1(Y)
    Xm1 = Minus1(X) ' X - 1
    Ym1 = Minus1(Y)
    bk = Plus1(bk) ' bk + 1

    If X > 0 Then
      If mss(Xm1, Y) = 0 Then
        'BC = tmpData1(Xm1, Y)
        If tmpData1(Xm1, Y) = DN Then
          mX = MunisXp(Xm1) ' - Xp
          mY = MunisYp(Y) '- Yp
          If SQRConts(SQR2(mX) + SQR2(mY)) < SZ2 Then
            CurPoint = CurPoint + 1
            pnt(CurPoint).X = Xm1
            pnt(CurPoint).Y = Y
            k = 1
            mss(Xm1, Y) = 1
          End If
        End If
      End If
    End If
    
    If X < W1 Then
      If mss(Xp1, Y) = 0 Then
        'BC = tmpData1(Xp1, Y)
        If tmpData1(Xp1, Y) = DN Then
          mX = MunisXp(Xp1) '- Xp
          mY = MunisYp(Y) '- Yp
          If SQRConts(SQR2(mX) + SQR2(mY)) < SZ2 Then
            CurPoint = CurPoint + 1
            pnt(CurPoint).X = Xp1
            pnt(CurPoint).Y = Y
            k = 1
            mss(Xp1, Y) = 1
          End If
        End If
      End If
    End If
    
    If Y > 0 Then
      If mss(X, Ym1) = 0 Then
        'BC = tmpData1(X, Ym1)
        If tmpData1(X, Ym1) = DN Then
          mX = MunisXp(X) ' - Xp
          mY = MunisYp(Ym1) ' - Yp
          If SQRConts(SQR2(mX) + SQR2(mY)) < SZ2 Then
            CurPoint = CurPoint + 1
            pnt(CurPoint).X = X
            pnt(CurPoint).Y = Ym1
            k = 1
            mss(X, Ym1) = 1
          End If
        End If
      End If
    End If
    
    If Y < H1 Then
      If mss(X, Yp1) = 0 Then
       ' BC = tmpData1(X, Yp1)
        If tmpData1(X, Yp1) = DN Then
          mX = MunisXp(X) ' - Xp
          mY = MunisYp(Yp1) ' - Yp
          If SQRConts(SQR2(mX) + SQR2(mY)) < SZ2 Then
            CurPoint = CurPoint + 1
            pnt(CurPoint).X = X
            pnt(CurPoint).Y = Yp1
            k = 1
            mss(X, Yp1) = 1
          End If
        End If
      End If
    End If
    
  Next
  OldPoint = OldPoint + bk
  Loop
End Sub

Sub MagicBrushColor(im As PictureBox, Xp, Yp, Color As Long, Color2 As Long, Size As Long)
  'tm = Timer
  Dim DN As Long
  Dim TC As Long
  Dim W As Long
  Dim H As Long
  Dim X As Long
  Dim Y As Long
  Dim x1 As Long
  Dim y1 As Long
  Dim x2 As Long
  Dim y2 As Long
  Dim mX As Long, mY As Long
  Dim SZ2 As Long
  SZ2 = SQR2(Size + 1)
  W = im.Width: H = im.Height
  TC = ReverseColor(Color)
  DN = ReverseColor(Color2)
  x1 = Xp - Size
  y1 = Yp - Size
  x2 = Xp + Size
  y2 = Yp + Size
  If x1 < 0 Then x1 = 0
  If y1 < 0 Then y1 = 0
  If x2 > W - 1 Then x2 = W - 1
  If y2 > H - 1 Then y2 = H - 1
  For Y = y1 To y2 Step 1
    mY = SQR2(Y - Yp)
    For X = x1 To x2 Step 1
      If tmpData(X, Y) = DN Then
        mX = X - Xp
        If SQR2(mX) + mY < SZ2 Then
          tmpData(X, Y) = TC
        End If
      End If
    Next X
  Next Y
  'frmMain.Caption = Int((Timer - tm) * 1000) / 1000
End Sub
Sub BrushColor(im As PictureBox, Xp, Yp, Color As Long, Size As Long)
  'tm = Timer
  Dim TC As Long
  Dim W As Long
  Dim H As Long
  Dim X As Long
  Dim Y As Long
  Dim x1 As Long
  Dim y1 As Long
  Dim x2 As Long
  Dim y2 As Long
  Dim mX As Long, mY As Long
  Dim SZ2 As Long
  Dim ms() As Long
  SZ2 = SQR2(Size + 1)
  W = im.Width: H = im.Height
  TC = ReverseColor(Color)
  x1 = Xp - Size
  y1 = Yp - Size
  x2 = Xp + Size
  y2 = Yp + Size
  If x1 < 0 Then x1 = 0
  If y1 < 0 Then y1 = 0
  If x2 > W - 1 Then x2 = W - 1
  If y2 > H - 1 Then y2 = H - 1
  If x2 < x1 Then Exit Sub
  If y2 < y1 Then Exit Sub
  
  ReDim ms(x1 To x2)
  '     X
  For X = x1 To x2 Step 1
    ms(X) = SQR2(X - Xp)
  Next
  
  For Y = y1 To y2 Step 1
    mY = SQR2(Y - Yp)
    For X = x1 To x2 Step 1
        'mX = X - Xp
        If ms(X) + mY < SZ2 Then
          tmpData(X, Y) = TC
        End If
    Next X
  Next Y
  'frmMain.Caption = Int((Timer - tm) * 1000) / 1000
End Sub

Sub BInversion(im As PictureBox)
  Dim BitmapInformation As BITMAPINFO
  Dim temp() As Long
  Dim X As Long
  Dim L As Long
  Dim C As RGBTriple
  Dim cR As Integer
  Dim cG As Integer
  Dim cB As Integer
  Dim Length As Long
  Dim Plus255(255) As Integer
  Dim b1 As Long, b2 As Long
  For L = 0 To 255
    Plus255(L) = L + 255
  Next
  
  W = im.Width: H = im.Height
  Length = W * H - 1
  ReDim temp(Length)
  With BitmapInformation.bmHeader
    .bmSize = Len(BitmapInformation.bmHeader)
    .bmBitCount = 32
    .bmClrImportant = 0
    .bmClrUsed = 0
    .bmCompression = BI_RGB
    .bmHeight = H
    .bmWidth = W
    .bmPlanes = 1
    .bmSizeImage = 0
    .bmXPelsPerMeter = 0
    .bmYPelsPerMeter = 0
  End With
  
  
  GetDIBits im.hdc, im.Image, CLng(0), H, temp(0), BitmapInformation, DIB_RGB_COLORS
  tm = Timer
  For X = 0 To Length Step 1
      CopyMemory C, temp(X), 3
      L = (CInt(C.Blue) + CInt(C.Green) + CInt(C.Red)) * 0.66666 'CSng(0.66666)
      cB = Plus255(C.Blue) - L
      cG = Plus255(C.Green) - L
      cR = Plus255(C.Red) - L
      If cB < 0 Then cB = 0 Else If cB > 255 Then cB = 255
      If cG < 0 Then cG = 0 Else If cG > 255 Then cG = 255
      If cR < 0 Then cR = 0 Else If cR > 255 Then cR = 255
      temp(X) = RGB(cB, cG, cR)
  Next X
  frmMain.clock(1).Caption = Int((Timer - tm) * 1000) / 1000 & " ."
  SetDIBits im.hdc, im.Image, CLng(0), H, temp(0), BitmapInformation, DIB_RGB_COLORS
  
End Sub

Sub BColors(im As PictureBox)
  Dim BitmapInformation As BITMAPINFO
  Dim temp() As Long
  Dim X As Long
  Dim L As Long
  Dim C As RGBTriple
  Dim cR As Integer
  Dim cG As Integer
  Dim cB As Integer
  Dim Length As Long
  Dim Plus255(255) As Integer
  Dim b1 As Long, b2 As Long
  For L = 0 To 255
    Plus255(L) = L + 255
  Next
  
  W = im.Width: H = im.Height
  Length = W * H - 1
  ReDim temp(Length)
  With BitmapInformation.bmHeader
    .bmSize = Len(BitmapInformation.bmHeader)
    .bmBitCount = 32
    .bmClrImportant = 0
    .bmClrUsed = 0
    .bmCompression = BI_RGB
    .bmHeight = H
    .bmWidth = W
    .bmPlanes = 1
    .bmSizeImage = 0
    .bmXPelsPerMeter = 0
    .bmYPelsPerMeter = 0
  End With
  
  
  GetDIBits im.hdc, im.Image, CLng(0), H, temp(0), BitmapInformation, DIB_RGB_COLORS
  tm = Timer
  For X = 0 To Length Step 1
      CopyMemory C, temp(X), 3
      temp(X) = GetColor(C.Blue, C.Green, C.Red)
  Next X
  frmMain.clock(1).Caption = Int((Timer - tm) * 1000) / 1000 & " ."
  SetDIBits im.hdc, im.Image, CLng(0), H, temp(0), BitmapInformation, DIB_RGB_COLORS
  
End Sub

Function GetColor(R, G, B) As Long
Dim nTemp As Single
Dim lMin As Long, lMax As Long, lDelta As Long
Dim H As Long, S As Long, L As Long
Dim cR As Long, cG As Long, cB As Long
Dim lH As Long
Dim nH As Single

  lMax = IIf(R > G, IIf(R > B, R, B), IIf(G > B, G, B))
  lMin = IIf(R < G, IIf(R < B, R, B), IIf(G < B, G, B))
  lDelta = lMax - lMin
  If lMax > 0 Then
    If lDelta > 0 Then
      If lMax = R Then
        nTemp = (G - B) / lDelta
      ElseIf lMax = G Then
        nTemp = 2 + (B - R) / lDelta
      Else
        nTemp = 4 + (R - G) / lDelta
      End If
      H = nTemp * 60
      If H < 0 Then H = H + 360
    End If
  End If
  
    nH = H * 0.016666
    lH = Int(nH)
    
    Select Case lH
    Case 0
      cR = 255
      cG = (nH - lH) * 255
      cB = 0
    Case 1
      cR = (1 - nH + lH) * 255
      cG = 255
      cB = 0
    Case 2
      cR = 0
      cG = 255
      cB = (nH - lH) * 255
    Case 3
      cR = 0
      cG = (1 - nH + lH) * 255
      cB = 255
    Case 4
      cR = (nH - lH) * 255
      cG = 0
      cB = 255
    Case 5
      cR = 255
      cG = 0
      cB = (1 - nH + lH) * 255
    End Select
  
  GetColor = RGB(cR, cG, cB)
End Function






